local MM = GetAddOnMetadata("MarkMe", "Title")
local MMVersionNum = GetAddOnMetadata("MarkMe", "Version")

DEFAULT_CHAT_FRAME:AddMessage(MM.. ' v.' ..MMVersionNum.. ' is loaded.')

local MMSettingsDefaults =
{
	locked = false,
	toggle_skull = true,
	toggle_cross = true,
	toggle_square = true,
	toggle_moon = true,
	toggle_triangle = true,
	toggle_diamond = true,
	toggle_circle = true,
	toggle_star = true,
	skull_line = "Skull - kill first",
	cross_line = "Cross - kill second",
	square_line = "Square - trap",
	moon_line = "Moon - sheep",
	triangle_line = "Triangle - ",
	diamond_line = "Diamond - ",
	circle_line = "Circle - ",
	star_line = "Star - ",
}

MMGLOBALS = {}

local defaultBackdrop = {
	bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
	tile = true,
	tileSize = 16,
	edgeSize = 16,
	insets = {left = 4, right = 4, top = 4, bottom = 4,}
}

local defaultBackdropSmall = {
	bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
	tile = true,
	tileSize = 12,
	edgeSize = 12,
	insets = {left = 4, right = 4, top = 4, bottom = 4,}
}

local borderlessBackdrop = {
	bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
	tile = true,
	tileSize = 16
}


------------- Main Frame -------------

mainFrame = CreateFrame("Frame", "mainFrame", UIParent)
mainFrame:SetBackdrop(borderlessBackdrop)
mainFrame:SetBackdropColor(0,0,0,0)
mainFrame:EnableMouse(true)
mainFrame:SetMovable(true)
mainFrame:SetUserPlaced(true)
mainFrame:SetUserPlaced(false)
mainFrame:SetSize(255,40)
mainFrame:SetPoint("CENTER", UIParent, "CENTER")
mainFrame:SetClampedToScreen(false)

------------- Icon Frame -------------

local iconFrame = CreateFrame("Frame", "iconFrame", mainFrame)
iconFrame:SetBackdrop(defaultBackdrop)
iconFrame:SetBackdropColor(0.1,0.1,0.1,0.7)
iconFrame:EnableMouse(true)
iconFrame:SetMovable(true)
iconFrame:SetSize(255,40)
iconFrame:SetPoint("LEFT", mainFrame, "LEFT")
iconFrame:SetScript("OnMouseDown", function(self,button) if (button=="LeftButton") then mainFrame:StartMoving() end end)
iconFrame:SetScript("OnMouseUp", function(self) mainFrame:StopMovingOrSizing() end)


------------- Readycheck Frame -------------

local ReadycheckFrame = CreateFrame("Frame", "ReadycheckFrame", mainFrame)
ReadycheckFrame:SetBackdrop(defaultBackdrop)
ReadycheckFrame:SetBackdropColor(0.1,0.1,0.1,0.7)
ReadycheckFrame:EnableMouse(true)
ReadycheckFrame:SetMovable(true)
ReadycheckFrame:SetSize(40, 40)
ReadycheckFrame:SetPoint("RIGHT", mainFrame, "LEFT")
ReadycheckFrame:SetScript("OnMouseDown", function(self,button) if (button=="LeftButton") then mainFrame:StartMoving() end end)
ReadycheckFrame:SetScript("OnMouseUp", function(self) mainFrame:StopMovingOrSizing() end)

------------- Announce Frame -------------

local AnnounceFrame = CreateFrame("Frame", "AnnounceFrame", mainFrame)
AnnounceFrame:SetBackdrop(defaultBackdrop)
AnnounceFrame:SetBackdropColor(0.1,0.1,0.1,0.7)
AnnounceFrame:EnableMouse(true)
AnnounceFrame:SetMovable(true)
AnnounceFrame:SetSize(40, 40)
AnnounceFrame:SetPoint("LEFT", mainFrame, "Right")
AnnounceFrame:SetScript("OnMouseDown", function(self,button) if (button=="LeftButton") then mainFrame:StartMoving() end end)
AnnounceFrame:SetScript("OnMouseUp", function(self) mainFrame:StopMovingOrSizing() end)


------------- Mark Buttons -------------
local iconSkull = CreateFrame("Button", "iconSkull", iconFrame)
iconSkull:SetSize(25,25)
iconSkull:SetPoint("LEFT", iconFrame, "LEFT",10,0)
iconSkull:SetNormalTexture("interface\\targetingframe\\ui-raidtargetingicons")
iconSkull:GetNormalTexture():SetTexCoord(0.75,1,0.25,0.5)
iconSkull:EnableMouse(true)
iconSkull:SetScript("OnClick", function(self) SetRaidTargetIcon("target", 8) end)
iconSkull:SetScript("OnMouseDown", function(self,button) if (button=="RightButton") then ToggleOP("Skull") end end)

local iconCross = CreateFrame("Button", "iconCross", iconFrame)
iconCross:SetSize(25,25)
iconCross:SetPoint("LEFT", iconSkull, "RIGHT", 5, 0)
iconCross:SetNormalTexture("interface\\targetingframe\\ui-raidtargetingicons")
iconCross:GetNormalTexture():SetTexCoord(0.5,0.75,0.25,0.5)
iconCross:EnableMouse(true)
iconCross:SetScript("OnClick", function(self) SetRaidTargetIcon("target", 7) end)
iconCross:SetScript("OnMouseDown", function(self,button) if (button=="RightButton") then ToggleOP("Cross") end end)

local iconSquare = CreateFrame("Button", "iconSquare", iconFrame)
iconSquare:SetSize(25,25)
iconSquare:SetPoint("LEFT", iconCross, "RIGHT", 5, 0)
iconSquare:SetNormalTexture("interface\\targetingframe\\ui-raidtargetingicons")
iconSquare:GetNormalTexture():SetTexCoord(0.25,0.5,0.25,0.5)
iconSquare:EnableMouse(true)
iconSquare:SetScript("OnClick", function(self) SetRaidTargetIcon("target", 6) end)
iconSquare:SetScript("OnMouseDown", function(self,button) if (button=="RightButton") then ToggleOP("Square") end end)

local iconMoon = CreateFrame("Button", "iconMoon", iconFrame)
iconMoon:SetSize(25,25)
iconMoon:SetPoint("LEFT", iconSquare, "RIGHT", 5, 0)
iconMoon:SetNormalTexture("interface\\targetingframe\\ui-raidtargetingicons")
iconMoon:GetNormalTexture():SetTexCoord(0,0.25,0.25,0.5)
iconMoon:EnableMouse(true)
iconMoon:SetScript("OnClick", function(self) SetRaidTargetIcon("target", 5) end)
iconMoon:SetScript("OnMouseDown", function(self,button) if (button=="RightButton") then ToggleOP("Moon") end end)

local iconTriangle = CreateFrame("Button", "iconTriangle", iconFrame)
iconTriangle:SetSize(25,25)
iconTriangle:SetPoint("LEFT", iconMoon, "RIGHT", 5, 0)
iconTriangle:SetNormalTexture("interface\\targetingframe\\ui-raidtargetingicons")
iconTriangle:GetNormalTexture():SetTexCoord(0.75,1,0,0.25)
iconTriangle:EnableMouse(true)
iconTriangle:SetScript("OnClick", function(self) SetRaidTargetIcon("target", 4) end)
iconTriangle:SetScript("OnMouseDown", function(self,button) if (button=="RightButton") then ToggleOP("Triangle") end end)

local iconDiamond = CreateFrame("Button", "iconDiamond", iconFrame)
iconDiamond:SetSize(25,25)
iconDiamond:SetPoint("LEFT", iconTriangle, "RIGHT", 5, 0)
iconDiamond:SetNormalTexture("interface\\targetingframe\\ui-raidtargetingicons")
iconDiamond:GetNormalTexture():SetTexCoord(0.5,0.75,0,0.25)
iconDiamond:EnableMouse(true)
iconDiamond:SetScript("OnClick", function(self) SetRaidTargetIcon("target", 3) end)
iconDiamond:SetScript("OnMouseDown", function(self,button) if (button=="RightButton") then ToggleOP("Diamond") end end)

local iconCircle = CreateFrame("Button", "iconCircle", iconFrame)
iconCircle:SetSize(25,25)
iconCircle:SetPoint("LEFT", iconDiamond, "RIGHT", 5, 0)
iconCircle:SetNormalTexture("interface\\targetingframe\\ui-raidtargetingicons")
iconCircle:GetNormalTexture():SetTexCoord(0.25,0.5,0,0.25)
iconCircle:EnableMouse(true)
iconCircle:SetScript("OnClick", function(self) SetRaidTargetIcon("target", 2) end)
iconCircle:SetScript("OnMouseDown", function(self,button) if (button=="RightButton") then ToggleOP("Circle") end end)

local iconStar = CreateFrame("Button", "iconStar", iconFrame)
iconStar:SetSize(25,25)
iconStar:SetPoint("LEFT", iconCircle, "RIGHT", 5, 0)
iconStar:SetNormalTexture("interface\\targetingframe\\ui-raidtargetingicons")
iconStar:GetNormalTexture():SetTexCoord(0,0.25,0,0.25)
iconStar:EnableMouse(true)
iconStar:SetScript("OnClick", function(self) SetRaidTargetIcon("target", 1) end)
iconStar:SetScript("OnMouseDown", function(self,button) if (button=="RightButton") then ToggleOP("Star") end end)

------------- Toggle Buttons -------------

local toggleSkull = CreateFrame("Button", "toggleSkull", iconFrame)
toggleSkull:SetSize(14,14)
toggleSkull:SetPoint("TOP", iconSkull, "BOTTOM",0,-6)
toggleSkull:SetNormalTexture("interface\\BUTTONS\\UI-CheckBox-Check")
toggleSkull:EnableMouse(false)

local toggleCross = CreateFrame("Button", "toggleCross", iconFrame)
toggleCross:SetSize(14,14)
toggleCross:SetPoint("TOP", iconCross, "BOTTOM", 0, -6)
toggleCross:SetNormalTexture("interface\\BUTTONS\\UI-CheckBox-Check")
toggleCross:EnableMouse(false)

local toggleSquare = CreateFrame("Button", "toggleSquare", iconFrame)
toggleSquare:SetSize(14,14)
toggleSquare:SetPoint("TOP", iconSquare, "BOTTOM", 0, -6)
toggleSquare:SetNormalTexture("interface\\BUTTONS\\UI-CheckBox-Check")
toggleSquare:EnableMouse(false)

local toggleMoon = CreateFrame("Button", "toggleMoon", iconFrame)
toggleMoon:SetSize(14,14)
toggleMoon:SetPoint("TOP", iconMoon, "BOTTOM", 0, -6)
toggleMoon:SetNormalTexture("interface\\BUTTONS\\UI-CheckBox-Check")
toggleMoon:EnableMouse(false)

local toggleTriangle = CreateFrame("Button", "toggleTriangle", iconFrame)
toggleTriangle:SetSize(14,14)
toggleTriangle:SetPoint("TOP", iconTriangle, "BOTTOM", 0, -6)
toggleTriangle:SetNormalTexture("interface\\BUTTONS\\UI-CheckBox-Check")
toggleTriangle:EnableMouse(false)

local toggleDiamond = CreateFrame("Button", "toggleDiamond", iconFrame)
toggleDiamond:SetSize(14,14)
toggleDiamond:SetPoint("TOP", iconDiamond, "BOTTOM", 0, -6)
toggleDiamond:SetNormalTexture("interface\\BUTTONS\\UI-CheckBox-Check")
toggleDiamond:EnableMouse(false)

local toggleCircle = CreateFrame("Button", "toggleCircle", iconFrame)
toggleCircle:SetSize(14,14)
toggleCircle:SetPoint("TOP", iconCircle, "BOTTOM", 0, -6)
toggleCircle:SetNormalTexture("interface\\BUTTONS\\UI-CheckBox-Check")
toggleCircle:EnableMouse(false)

local toggleStar = CreateFrame("Button", "toggleStar", iconFrame)
toggleStar:SetSize(14,14)
toggleStar:SetPoint("TOP", iconStar, "BOTTOM", 0, -6)
toggleStar:SetNormalTexture("interface\\BUTTONS\\UI-CheckBox-Check")
toggleStar:EnableMouse(false)


------------- Readycheck Button -------------

local Readycheck = CreateFrame("Button", "Readycheck", ReadycheckFrame)
Readycheck:SetSize(28,28)
Readycheck:SetPoint("CENTER", ReadycheckFrame , "CENTER", 0, 0)
Readycheck:SetNormalTexture("Interface\\RAIDFRAME\\ReadyCheck-Ready")
Readycheck:EnableMouse(true)
Readycheck:SetScript("OnClick", function(self) DoReadyCheck() end)



------------- Lock Button -------------
local lockIcon = CreateFrame("Button", "lockIcon", mainFrame)
lockIcon:SetSize(10,10)
lockIcon:SetPoint("TOPLEFT", AnnounceFrame , "TOPRIGHT", 0, -3)
lockIcon:SetNormalTexture("Interface\\GLUES\\CharacterSelect\\Glues-Addon-Icons")
lockIcon:GetNormalTexture():SetTexCoord(0.25, 0.50, 0, 1)
lockIcon:EnableMouse(true)
lockIcon:SetScript("OnClick", function(self) lockToggle() end)

------------- Settings Button -------------
local settingsIcon = CreateFrame("Button", "settingsIcon", mainFrame)
settingsIcon:SetSize(10,10)
settingsIcon:SetPoint("BOTTOMLEFT", AnnounceFrame , "BOTTOMRIGHT", 0, 3)
settingsIcon:SetNormalTexture("Interface\\GossipFrame\\BinderGossipIcon")

settingsIcon:EnableMouse(true)
settingsIcon:SetScript("OnClick", function(self) OpenOptions() end)



------------- Announce Button -------------
local announceIcon = CreateFrame("Button", "announceIcon", AnnounceFrame)
announceIcon:SetSize(28,28)
announceIcon:SetPoint("CENTER", AnnounceFrame , "CENTER", 0, 0)
announceIcon:SetNormalTexture("Interface\\CURSOR\\Speak")

announceIcon:EnableMouse(true)
announceIcon:SetScript("OnClick", function(self) EchoNYI() end)


function lock()
		MMSettings.locked = true
		iconFrame:EnableMouse(false)
		ReadycheckFrame:EnableMouse(false)
		AnnounceFrame:EnableMouse(false)
        lockIcon:GetNormalTexture():SetTexCoord(0, 0.25, 0, 1)
end

function unlock()
		MMSettings.locked = false
		iconFrame:EnableMouse(true)
		ReadycheckFrame:EnableMouse(true)
		AnnounceFrame:EnableMouse(true)
        lockIcon:GetNormalTexture():SetTexCoord(0.25, 0.50, 0, 1)
end

function lockToggle()
      if MMSettings.locked then unlock() else lock() end
end

------------- OPs -------------

function Init()
	if (MMSettings == nil) then 
	SetDefaultSettings() 
	else 
	---lockCheck:SetChecked(MMSettings.locked)
	InitToggles()
	end
end

function SetDefaultSettings()
	MMSettings = MMSettingsDefaults
end

function InitToggles()
	ToggleOP("Skull")
	ToggleOP("Cross")
	ToggleOP("Square")
	ToggleOP("Moon")
	ToggleOP("Triangle")
	ToggleOP("Diamond")
	ToggleOP("Circle")
	ToggleOP("Star")
end

function ToggleOP(symbol)
	if (symbol == "Skull") then
		if (MMSettings.toggle_skull) then
		MMSettings.toggle_skull = false
		toggleSkull:Hide()
		else
		MMSettings.toggle_skull = true
		toggleSkull:Show()
		end
	end
	if (symbol == "Cross") then
		if (MMSettings.toggle_cross) then
		MMSettings.toggle_cross = false
		toggleCross:Hide()
		else
		MMSettings.toggle_cross= true
		toggleCross:Show()
		end
	end
	if (symbol == "Square") then
		if (MMSettings.toggle_square) then
		MMSettings.toggle_square = false
		toggleSquare:Hide()
		else
		MMSettings.toggle_square= true
		toggleSquare:Show()
		end
	end
	if (symbol == "Moon") then
		if (MMSettings.toggle_moon) then
		MMSettings.toggle_moon = false
		toggleMoon:Hide()
		else
		MMSettings.toggle_moon = true
		toggleMoon:Show()
		end
	end
	if (symbol == "Triangle") then
		if (MMSettings.toggle_triangle) then
		MMSettings.toggle_triangle = false
		toggleTriangle:Hide()
		else
		MMSettings.toggle_triangle = true
		toggleTriangle:Show()
		end
	end
	if (symbol == "Diamond") then
		if (MMSettings.toggle_diamond) then
		MMSettings.toggle_diamond = false
		toggleDiamond:Hide()
		else
		MMSettings.toggle_diamond = true
		toggleDiamond:Show()
		end
	end
	if (symbol == "Circle") then
		if (MMSettings.toggle_circle) then
		MMSettings.toggle_circle= false
		toggleCircle:Hide()
		else
		MMSettings.toggle_circle = true
		toggleCircle:Show()
		end
	end
	if (symbol == "Star") then
		if (MMSettings.toggle_star) then
		MMSettings.toggle_star= false
		toggleStar:Hide()
		else
		MMSettings.toggle_star = true
		toggleStar:Show()
		end
	end
end

----------------- Party Checker ----------
function PartyChecker()   
    if (IsInGroup()) then -- IN A PARTY OR RAID
			if (IsInRaid()) then -- IN A RAID
				if (UnitIsGroupLeader("player") or UnitIsGroupAssistant("player")) then
					ReadycheckFrame:Show()
					AnnounceFrame:Show()
				else
					ReadycheckFrame:Hide()
					AnnounceFrame:Hide()
				end
			else -- IN APARTY
				if (UnitIsGroupLeader("player")) then
					ReadycheckFrame:Show()
					AnnounceFrame:Show()
				else
					ReadycheckFrame:Hide()
					AnnounceFrame:Hide()
				end
			end
		else -- NOT IN ANY GROUP
			ReadycheckFrame:Show()
			AnnounceFrame:Show()
		end
   
end


function OpenOptions ()
InterfaceOptionsFrame_OpenToCategory(MarkMeOptions.panel)
end

function EchoNYI()
print("This feature is coming soon")
end

------------- Settings -------------

MarkMeOptions = {};
MarkMeOptions.panel = CreateFrame( "Frame", "MarkMeOptions", InterfaceOptionsFramePanelContainer );
MarkMeOptions.panel.name = "Mark Me";
MarkMeOptions.panel.okay = function(self) MM_Save(); end
MarkMeOptions.panel.cancel = function(self) MM_Save(); end
MarkMeOptions.panel.default = function(self) MM_Save(); MM_Save(); end
MarkMeOptions.panel.refresh = function(self) MM_Save(); MM_Save(); end
InterfaceOptions_AddCategory(MarkMeOptions.panel);

local OptionsText = MarkMeOptions.panel:CreateFontString("OptionsText", "OVERLAY", "ChatFontNormal")
OptionsText:SetPoint("TOP", MarkMeOptions.panel, "TOP",0,-10)
OptionsText:SetText(MM.."|cffe1a500 Options")


local NYIText = MarkMeOptions.panel:CreateFontString("NYIText", "OVERLAY", "ChatFontNormal")
NYIText:SetPoint("TOP", OptionsText, "BOTTOM",0,-10)
NYIText:SetText("This feature is coming soon")

------------- Settings  OPs -------------

function MM_Save()
MMSettings = MMSettingsDefaults
end


------------- Events -------------
local MM_OnUpdate = CreateFrame("Frame")
MM_OnUpdate:RegisterEvent("ADDON_LOADED")
MM_OnUpdate:RegisterEvent("PLAYER_LOGIN")
MM_OnUpdate:RegisterEvent("PLAYER_LOGOUT")
MM_OnUpdate:RegisterEvent("GROUP_ROSTER_UPDATE")


MM_OnUpdate:SetScript("OnEvent", function(self,event,addon,...)
	
	if (event=="ADDON_LOADED" and addon=="MarkMe") then
	Init();
	PartyChecker()
	-----	if (MMSettings.locked) then lock() else unlock() end
	end
	
	
	if (event=="PLAYER_LOGIN") then
	if (MMSettings.locked) then lock() else unlock() end
	end
	
	
	if (event=="PLAYER_LOGOUT") then
		MM_Save()
	end
	
	if (event=="GROUP_ROSTER_UPDATE") then
		PartyChecker()
    end
end
)